<?php

namespace FiloBlu\CustomerGrid\Model\ResourceModel\Grid;

class Collection extends \Magento\Customer\Model\ResourceModel\Grid\Collection
{
    /**
     * @param array|string $field
     * @param null $condition
     * @return \Magento\Framework\View\Element\UiComponent\DataProvider\SearchResult
     */
    public function addFieldToFilter( $field, $condition = null)
    {
       if ($field == 'customer_segment') {
            $field = 'thirdTable.name';
        }
        if ($field == 'website_id') {
            $field = 'main_table.website_id';
        }
        if ($field == 'name') {
            $field = 'main_table.name';
        }

        return parent::addFieldToFilter($field, $condition);
    }

    /**
     * @return $this|\Magento\Framework\View\Element\UiComponent\DataProvider\SearchResult|void
     */
    protected function _initSelect()
    {
        parent::_initSelect();
        $this->getSelect()
           ->joinLeft(
                ['customer_log' => $this->getTable('customer_log')],
                'customer_log.customer_id = main_table.entity_id',
                ['last_login_at']
            )
            ->joinLeft(
                ['secondTable' => $this->getTable('magento_customersegment_customer')],
                'main_table.entity_id = secondTable.customer_id',
                ['segment_id']
            )->joinLeft(
                ['thirdTable' => $this->getTable('magento_customersegment_segment')],
                'secondTable.segment_id = thirdTable.segment_id',
                ['customer_segment' => "group_concat(DISTINCT thirdTable.name)"]
            )->group('main_table.entity_id');

        return $this;
    }
}